HexMessage = LibStub("AceAddon-3.0"): NewAddon("HexMessage", "AceEvent-3.0", "AceTimer-3.0")
local hexmessage_opt = {
	name = "HexMessage",
	handler = HexMessage,
	type = 'group',
	args = {
		party = {
			type = 'input',
			name = 'Send to Party',
			desc = 'Send an encoded message to your party',
			set = 'SendPartyMsg',
			get = 'dummyfunc',
		},
		raid = {
			type = 'input',
			name = 'Send to Raid',
			desc = 'Send an encoded message to your raid',
			set = 'SendRaidMsg',
			get = 'dummyfunc',
		},
		guild = {
			type = 'input',
			name = 'Send to Guild',
			desc = 'Send an encoded message to your guild',
			set = 'SendGuildMsg',
			get = 'dummyfunc',
		},
		bg = {
			type = 'input',
			name = 'Send to Battleground',
			desc = 'Send an encoded message to the battleground channel',
			set = 'SendGuildMsg',
			get = 'dummyfunc',
		},
		whisper = {
			type = 'input',
			name = 'Send to Battleground',
			desc = 'Send an encoded whisper to another player',
			set = 'SendPstMsg',
			get = 'dummyfunc',
		},
	},
}
DEFAULT_CHAT_FRAME:AddMessage("HexMessage loaded.");

function HexMessage:TranslateToHex(input)
	input = string.gsub(input, " ", "_#_TWO_#__#_ZERO_#_ ");
	input = string.gsub(input, "0", "_#_THREE_#__#_ZERO_#_ ");
	input = string.gsub(input, "1", "_#_THREE_#__#_ONE_#_ ");
	input = string.gsub(input, "2", "_#_THREE_#__#_TWO_#_ ");
	input = string.gsub(input, "3", "_#_THREE_#__#_THREE_#_ ");
	input = string.gsub(input, "4", "_#_THREE_#__#_FOUR_#_ ");
	input = string.gsub(input, "5", "_#_THREE_#__#_FIVE_#_ ");
	input = string.gsub(input, "6", "_#_THREE_#__#_SIX_#_ ");
	input = string.gsub(input, "7", "_#_THREE_#__#_SEVEN_#_ ");
	input = string.gsub(input, "8", "_#_THREE_#__#_EIGHT_#_ ");
	input = string.gsub(input, "9", "_#_THREE_#__#_NINE_#_ ");
	input = string.gsub(input, "_#_ZERO_#_", "0");
	input = string.gsub(input, "_#_ONE_#_", "1");
	input = string.gsub(input, "_#_TWO_#_", "2");
	input = string.gsub(input, "_#_THREE_#_", "3");
	input = string.gsub(input, "_#_FOUR_#_", "4");
	input = string.gsub(input, "_#_FIVE_#_", "5");
	input = string.gsub(input, "_#_SIX_#_", "6");
	input = string.gsub(input, "_#_SEVEN_#_", "7");
	input = string.gsub(input, "_#_EIGHT_#_", "8");
	input = string.gsub(input, "_#_NINE_#_", "9");
	input = string.gsub(input, "a", "61 ");
	input = string.gsub(input, "b", "62 ");
	input = string.gsub(input, "c", "63 ");
	input = string.gsub(input, "d", "64 ");
	input = string.gsub(input, "e", "65 ");
	input = string.gsub(input, "f", "66 ");
	input = string.gsub(input, "g", "67 ");
	input = string.gsub(input, "h", "68 ");
	input = string.gsub(input, "i", "69 ");
	input = string.gsub(input, "j", "6a ");
	input = string.gsub(input, "k", "6b ");
	input = string.gsub(input, "l", "6c ");
	input = string.gsub(input, "m", "6d ");
	input = string.gsub(input, "n", "6e ");
	input = string.gsub(input, "o", "6f ");
	input = string.gsub(input, "p", "70 ");
	input = string.gsub(input, "q", "71 ");
	input = string.gsub(input, "r", "72 ");
	input = string.gsub(input, "s", "73 ");
	input = string.gsub(input, "t", "74 ");
	input = string.gsub(input, "u", "75 ");
	input = string.gsub(input, "v", "76 ");
	input = string.gsub(input, "w", "77 ");
	input = string.gsub(input, "x", "78 ");
	input = string.gsub(input, "y", "79 ");
	input = string.gsub(input, "z", "7a ");
	input = string.gsub(input, "A", "41 ");
	input = string.gsub(input, "B", "42 ");
	input = string.gsub(input, "C", "43 ");
	input = string.gsub(input, "D", "44 ");
	input = string.gsub(input, "E", "45 ");
	input = string.gsub(input, "F", "46 ");
	input = string.gsub(input, "G", "47 ");
	input = string.gsub(input, "H", "48 ");
	input = string.gsub(input, "I", "49 ");
	input = string.gsub(input, "J", "4a ");
	input = string.gsub(input, "K", "4b ");
	input = string.gsub(input, "L", "4c ");
	input = string.gsub(input, "M", "4d ");
	input = string.gsub(input, "N", "4e ");
	input = string.gsub(input, "O", "4f ");
	input = string.gsub(input, "P", "50 ");
	input = string.gsub(input, "Q", "51 ");
	input = string.gsub(input, "R", "52 ");
	input = string.gsub(input, "S", "53 ");
	input = string.gsub(input, "T", "54 ");
	input = string.gsub(input, "U", "55 ");
	input = string.gsub(input, "V", "56 ");
	input = string.gsub(input, "W", "57 ");
	input = string.gsub(input, "X", "58 ");
	input = string.gsub(input, "Y", "59 ");
	input = string.gsub(input, "Z", "5a ");
	input = string.gsub(input, "%[", "5b ");
	input = string.gsub(input, "\\", "5c ");
	input = string.gsub(input, "%]", "5d ");
	input = string.gsub(input, "%^", "5e ");
	input = string.gsub(input, "_", "5f ");
	input = string.gsub(input, "`", "60 ");
	input = string.gsub(input, "@", "40 ");
	input = string.gsub(input, "%:", "3a ");
	input = string.gsub(input, ";", "3b ");
	input = string.gsub(input, "<", "3c ");
	input = string.gsub(input, "=", "3d ");
	input = string.gsub(input, ">", "3e ");
	input = string.gsub(input, "%?", "3f ");
	input = string.gsub(input, "!", "21 ");
	input = string.gsub(input, "\"", "22 ");
	input = string.gsub(input, "#", "23 ");
	input = string.gsub(input, "%$", "24 ");
	input = string.gsub(input, "%%", "25 ");
	input = string.gsub(input, "&", "26 ");
	input = string.gsub(input, "'", "27 ");
	input = string.gsub(input, "%(", "28 ");
	input = string.gsub(input, "%)", "29 ");
	input = string.gsub(input, "%*", "2a ");
	input = string.gsub(input, "%+", "2b ");
	input = string.gsub(input, "%,", "2c ");
	input = string.gsub(input, "%-", "2d ");
	input = string.gsub(input, "%.", "2e ");
	input = string.gsub(input, "/", "2f ");
	return input
end
function HexMessage:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("HexMessage", hexmessage_opt, {"hexmessage", "hex"});
end

function HexMessage:OnEnable()
	self:RegisterEvent("CHAT_MSG_ADDON")
end

function HexMessage:CHAT_MSG_ADDON(event, prefix, message, dist, sender)
	if prefix == "HexMessage" then
		DEFAULT_CHAT_FRAME:AddMessage("<HexMessage>"..sender..": "..message);
	end
end

function HexMessage:dummyfunc()
	return nil
end

function HexMessage:SendPartyMsg(info, input)
	local hexmsg = HexMessage:TranslateToHex(input);
	SendChatMessage("[Hexadecimal] "..hexmsg, "PARTY");
	SendAddonMessage("HexMessage", input, "PARTY");
end

function HexMessage:SendRaidMsg(info, input)
	local hexmsg = HexMessage:TranslateToHex(input);
	SendChatMessage("[Hexadecimal] "..hexmsg, "RAID");
	SendAddonMessage("HexMessage", input, "RAID");
end

function HexMessage:SendGuildMsg(info, input)
	local hexmsg = HexMessage:TranslateToHex(input);
	SendChatMessage("[Hexadecimal] "..hexmsg, "GUILD");
	SendAddonMessage("HexMessage", input, "GUILD");
end

function HexMessage:SendPstMsg(info, input)
	local a = string.match(input, "%S+");
	local b = string.gsub(input, a.." ", "", 1);
	local c = HexMessage:TranslateToHex(b);
	SendChatMessage("[Hexadecimal] "..c, "WHISPER", nil, a);
	SendAddonMessage("HexMessage", b, "WHISPER", a);
end
